namespace AVStantso.TS {
  type Unused<N extends number> = `Unused${N}`;

  /**
   * @summary `ASCII` characters
   * @see https://www.ascii-code.com/
   */
  export type ASCII = [
    // ASCII control characters (character code 0-31)
    '␀',
    '␁',
    '␂',
    '␃',
    '␄',
    '␅',
    '␆',
    '␇',
    '␈',
    '␉',
    '␊',
    '␋',
    '␌',
    '␍',
    '␎',
    '␏',
    '␐',
    '␑',
    '␒',
    '␓',
    '␔',
    '␕',
    '␖',
    '␗',
    '␘',
    '␙',
    '␚',
    '␛',
    '␜',
    '␝',
    '␞',
    '␟',

    // ASCII printable characters (character code 32-127)
    ' ',
    '!',
    '"',
    '#',
    '$',
    '%',
    '&',
    "'",
    '(',
    ')',
    '*',
    '+',
    ',',
    '-',
    '.',
    '/',
    '0',
    '1',
    '2',
    '3',
    '4',
    '5',
    '6',
    '7',
    '8',
    '9',
    ':',
    ';',
    '<',
    '=',
    '>',
    '?',
    '@',
    'A',
    'B',
    'C',
    'D',
    'E',
    'F',
    'G',
    'H',
    'I',
    'J',
    'K',
    'L',
    'M',
    'N',
    'O',
    'P',
    'Q',
    'R',
    'S',
    'T',
    'U',
    'V',
    'W',
    'X',
    'Y',
    'Z',
    '[',
    '\\',
    ']',
    '^',
    '_',
    '`',
    'a',
    'b',
    'c',
    'd',
    'e',
    'f',
    'g',
    'h',
    'i',
    'j',
    'k',
    'l',
    'm',
    'n',
    'o',
    'p',
    'q',
    'r',
    's',
    't',
    'u',
    'v',
    'w',
    'x',
    'y',
    'z',
    '{',
    '|',
    '}',
    '~',
    '␡',

    // The extended ASCII codes (character code 128-255)
    '€',
    Unused<0>,
    '‚',
    'ƒ',
    '„',
    '…',
    '†',
    '‡',
    'ˆ',
    '‰',
    'Š',
    '‹',
    'Œ',
    Unused<1>,
    'Ž',
    Unused<2>,
    Unused<3>,
    '‘',
    '’',
    '“',
    '”',
    '•',
    '–',
    '—',
    '˜',
    '™',
    'š',
    '›',
    'œ',
    Unused<4>,
    'ž',
    'Ÿ',
    'NBSP',
    '¡',
    '¢',
    '£',
    '¤',
    '¥',
    '¦',
    '§',
    '¨',
    '©',
    'ª',
    '«',
    '¬',
    'SHY',
    '®',
    '¯',
    '°',
    '±',
    '²',
    '³',
    '´',
    'µ',
    '¶',
    '·',
    '¸',
    '¹',
    'º',
    '»',
    '¼',
    '½',
    '¾',
    '¿',
    'À',
    'Á',
    'Â',
    'Ã',
    'Ä',
    'Å',
    'Æ',
    'Ç',
    'È',
    'É',
    'Ê',
    'Ë',
    'Ì',
    'Í',
    'Î',
    'Ï',
    'Ð',
    'Ñ',
    'Ò',
    'Ó',
    'Ô',
    'Õ',
    'Ö',
    '×',
    'Ø',
    'Ù',
    'Ú',
    'Û',
    'Ü',
    'Ý',
    'Þ',
    'ß',
    'à',
    'á',
    'â',
    'ã',
    'ä',
    'å',
    'æ',
    'ç',
    'è',
    'é',
    'ê',
    'ë',
    'ì',
    'í',
    'î',
    'ï',
    'ð',
    'ñ',
    'ò',
    'ó',
    'ô',
    'õ',
    'ö',
    '÷',
    'ø',
    'ù',
    'ú',
    'û',
    'ü',
    'ý',
    'þ',
    'ÿ'
  ];

  export namespace ASCII {
    /**
     * @summary ASCII characters map char-code
     */
    export namespace Map {
      /**
       * @summary ASCII control characters (character code `0-31`)
       */
      export type Control = Array.KeyValueMapFrom<Array.Sub<ASCII, 0, 31>>;

      /**
       * @summary ASCII printable characters (character code `32-127`)
       */
      export type Printable = Array.KeyValueMapFrom<
        Array.Sub<ASCII, 32, 127>,
        32
      >;

      /**
       * @summary The extended ASCII codes (character code `128-255`)
       */
      export type Extended = Array.KeyValueMapFrom<
        Array.Sub<ASCII, 128, 255>,
        128
      >;
    }

    export type Map = Array.KeyValueMapFrom<ASCII>;

    export type _Code<
      S extends string,
      R extends number = Extract<ASCII.Map[Extract<S, keyof ASCII.Map>], number>
    > = R;

    /**
     * @summary Get ASCII characters code. `never` if `S` is not a chracter
     */
    export type Code<S extends string> = _Code<S>;
  }
}
